package BankApp;


/**
* BankApp/_BankStub.java .
*  IDL-to-Java ֲ汾 "3.2" 
*  ./bankidl/bank.idl
* 2006315  08ʱ4232 EST
*/

public class _BankStub extends org.omg.CORBA.portable.ObjectImpl implements BankApp.Bank
{

  public int Open (String opID)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("Open", true);
                $out.write_string (opID);
                $in = _invoke ($out);
                int $result = $in.read_long ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return Open (opID        );
            } finally {
                _releaseReply ($in);
            }
  } // Open

  public float Deposit (String opID, int acnt, float amt)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("Deposit", true);
                $out.write_string (opID);
                $out.write_long (acnt);
                $out.write_float (amt);
                $in = _invoke ($out);
                float $result = $in.read_float ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return Deposit (opID, acnt, amt        );
            } finally {
                _releaseReply ($in);
            }
  } // Deposit

  public float Withdraw (String opID, int acnt, float amt)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("Withdraw", true);
                $out.write_string (opID);
                $out.write_long (acnt);
                $out.write_float (amt);
                $in = _invoke ($out);
                float $result = $in.read_float ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return Withdraw (opID, acnt, amt        );
            } finally {
                _releaseReply ($in);
            }
  } // Withdraw

  public float Balance (String opID, int acnt)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("Balance", true);
                $out.write_string (opID);
                $out.write_long (acnt);
                $in = _invoke ($out);
                float $result = $in.read_float ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return Balance (opID, acnt        );
            } finally {
                _releaseReply ($in);
            }
  } // Balance

  public float Transfer (String opID, int src, int dest, float amount)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("Transfer", true);
                $out.write_string (opID);
                $out.write_long (src);
                $out.write_long (dest);
                $out.write_float (amount);
                $in = _invoke ($out);
                float $result = $in.read_float ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return Transfer (opID, src, dest, amount        );
            } finally {
                _releaseReply ($in);
            }
  } // Transfer

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:BankApp/Bank:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _BankStub
